## afl 2.49b

=== Makefile ===
#
# american fuzzy lop - makefile
# -----------------------------
#
# Written and maintained by Michal Zalewski <lcamtuf@google.com>
# 
# Copyright 2013, 2014, 2015, 2016 Google Inc. All rights reserved.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
# 
#   http://www.apache.org/licenses/LICENSE-2.0
#

PROGNAME    = afl
VERSION     = $(shell grep '^\#define VERSION ' config.h | cut -d '"' -f2)

PREFIX     ?= /usr/local
BIN_PATH    = $(PREFIX)/bin
HELPER_PATH = $(PREFIX)/lib/afl
DOC_PATH    = $(PREFIX)/share/doc/afl
MISC_PATH   = $(PREFIX)/share/afl

# PROGS intentionally omit afl-as, which gets installed elsewhere.

PROGS       = afl-gcc afl-fuzz afl-showmap afl-tmin afl-gotcpu afl-analyze
SH_PROGS    = afl-plot afl-cmin afl-whatsup

CFLAGS     ?= -O3 -funroll-loops
CFLAGS     += -Wall -D_FORTIFY_SOURCE=2 -g -Wno-pointer-sign \
	      -DAFL_PATH=\"$(HELPER_PATH)\" -DDOC_PATH=\"$(DOC_PATH)\" \
	      -DBIN_PATH=\"$(BIN_PATH)\"

ifneq "$(filter Linux GNU%,$(shell uname))" ""
  LDFLAGS  += -ldl
endif

ifeq "$(findstring clang, $(shell $(CC) --version 2>/dev/null))" ""
  TEST_CC   = afl-gcc
else
  TEST_CC   = afl-clang
endif

COMM_HDR    = alloc-inl.h config.h debug.h types.h

all: test_x86 $(PROGS) afl-as test_build all_done

ifndef AFL_NO_X86

test_x86:
	@echo "[*] Checking for the ability to compile x86 code..."
	@echo 'main() { __asm__("xorb %al, %al"); }' | $(CC) -w -x c - -o .test || ( echo; echo "Oops, looks like your compiler can't generate x86 code."; echo; echo "Don't panic! You can use the LLVM or QEMU mode, but see docs/INSTALL first."; echo "(To ignore this error, set AFL_NO_X86=1 and try again.)"; echo; exit 1 )
	@rm -f .test
	@echo "[+] Everything seems to be working, ready to compile."

else

test_x86:
	@echo "[!] Note: skipping x86 compilation checks (AFL_NO_X86 set)."

endif

afl-gcc: afl-gcc.c $(COMM_HDR) | test_x86
	$(CC) $(CFLAGS) $@.c -o $@ $(LDFLAGS)
	set -e; for i in afl-g++ afl-clang afl-clang++; do ln -sf afl-gcc $$i; done

afl-as: afl-as.c afl-as.h $(COMM_HDR) | test_x86
	$(CC) $(CFLAGS) $@.c -o $@ $(LDFLAGS)
	ln -sf afl-as as

afl-fuzz: afl-fuzz.c $(COMM_HDR) | test_x86
	$(CC) $(CFLAGS) $@.c -o $@ $(LDFLAGS)

afl-showmap: afl-showmap.c $(COMM_HDR) | test_x86
	$(CC) $(CFLAGS) $@.c -o $@ $(LDFLAGS)

afl-tmin: afl-tmin.c $(COMM_HDR) | test_x86
	$(CC) $(CFLAGS) $@.c -o $@ $(LDFLAGS)

afl-analyze: afl-analyze.c $(COMM_HDR) | test_x86
	$(CC) $(CFLAGS) $@.c -o $@ $(LDFLAGS)

afl-gotcpu: afl-gotcpu.c $(COMM_HDR) | test_x86
	$(CC) $(CFLAGS) $@.c -o $@ $(LDFLAGS)

ifndef AFL_NO_X86

test_build: afl-gcc afl-as afl-showmap
	@echo "[*] Testing the CC wrapper and instrumentation output..."
	unset AFL_USE_ASAN AFL_USE_MSAN; AFL_QUIET=1 AFL_INST_RATIO=100 AFL_PATH=. ./$(TEST_CC) $(CFLAGS) test-instr.c -o test-instr $(LDFLAGS)
	echo 0 | ./afl-showmap -m none -q -o .test-instr0 ./test-instr
	echo 1 | ./afl-showmap -m none -q -o .test-instr1 ./test-instr
	@rm -f test-instr
	@cmp -s .test-instr0 .test-instr1; DR="$$?"; rm -f .test-instr0 .test-instr1; if [ "$$DR" = "0" ]; then echo; echo "Oops, the instrumentation does not seem to be behaving correctly!"; echo; echo "Please ping <lcamtuf@google.com> to troubleshoot the issue."; echo; exit 1; fi
	@echo "[+] All right, the instrumentation seems to be working!"

else

test_build: afl-gcc afl-as afl-showmap
	@echo "[!] Note: skipping build tests (you may need to use LLVM or QEMU mode)."

endif

all_done: test_build
	@if [ ! "`which clang 2>/dev/null`" = "" ]; then echo "[+] LLVM users: see llvm_mode/README.llvm for a faster alternative to afl-gcc."; fi
	@echo "[+] All done! Be sure to review README - it's pretty short and useful."
	@if [ "`uname`" = "Darwin" ]; then printf "\nWARNING: Fuzzing on MacOS X is slow because of the unusually high overhead of\nfork() on this OS. Consider using Linux or *BSD. You can also use VirtualBox\n(virtualbox.org) to put AFL inside a Linux or *BSD VM.\n\n"; fi
	@! tty <&1 >/dev/null || printf "\033[0;30mNOTE: If you can read this, your terminal probably uses white background.\nThis will make the UI hard to read. See docs/status_screen.txt for advice.\033[0m\n" 2>/dev/null

.NOTPARALLEL: clean

clean:
	rm -f $(PROGS) afl-as as afl-g++ afl-clang afl-clang++ *.o *~ a.out core core.[1-9][0-9]* *.stackdump test .test test-instr .test-instr0 .test-instr1 qemu_mode/qemu-2.3.0.tar.bz2 afl-qemu-trace
	rm -rf out_dir qemu_mode/qemu-2.3.0
	$(MAKE) -C llvm_mode clean
	$(MAKE) -C libdislocator clean
	$(MAKE) -C libtokencap clean

install: all
	mkdir -p -m 755 $${DESTDIR}$(BIN_PATH) $${DESTDIR}$(HELPER_PATH) $${DESTDIR}$(DOC_PATH) $${DESTDIR}$(MISC_PATH)
	rm -f $${DESTDIR}$(BIN_PATH)/afl-plot.sh
	install -m 755 $(PROGS) $(SH_PROGS) $${DESTDIR}$(BIN_PATH)
	rm -f $${DESTDIR}$(BIN_PATH)/afl-as
	if [ -f afl-qemu-trace ]; then install -m 755 afl-qemu-trace $${DESTDIR}$(BIN_PATH); fi
ifndef AFL_TRACE_PC
	if [ -f afl-clang-fast -a -f afl-llvm-pass.so -a -f afl-llvm-rt.o ]; then set -e; install -m 755 afl-clang-fast $${DESTDIR}$(BIN_PATH); ln -sf afl-clang-fast $${DESTDIR}$(BIN_PATH)/afl-clang-fast++; install -m 755 afl-llvm-pass.so afl-llvm-rt.o $${DESTDIR}$(HELPER_PATH); fi
else
	if [ -f afl-clang-fast -a -f afl-llvm-rt.o ]; then set -e; install -m 755 afl-clang-fast $${DESTDIR}$(BIN_PATH); ln -sf afl-clang-fast $${DESTDIR}$(BIN_PATH)/afl-clang-fast++; install -m 755 afl-llvm-rt.o $${DESTDIR}$(HELPER_PATH); fi
endif
	if [ -f afl-llvm-rt-32.o ]; then set -e; install -m 755 afl-llvm-rt-32.o $${DESTDIR}$(HELPER_PATH); fi
	if [ -f afl-llvm-rt-64.o ]; then set -e; install -m 755 afl-llvm-rt-64.o $${DESTDIR}$(HELPER_PATH); fi
	set -e; for i in afl-g++ afl-clang afl-clang++; do ln -sf afl-gcc $${DESTDIR}$(BIN_PATH)/$$i; done
	install -m 755 afl-as $${DESTDIR}$(HELPER_PATH)
	ln -sf afl-as $${DESTDIR}$(HELPER_PATH)/as
	install -m 644 docs/README docs/ChangeLog docs/*.txt $${DESTDIR}$(DOC_PATH)
	cp -r testcases/ $${DESTDIR}$(MISC_PATH)
	cp -r dictionaries/ $${DESTDIR}$(MISC_PATH)

publish: clean
	test "`basename $$PWD`" = "afl" || exit 1
	test -f ~/www/afl/releases/$(PROGNAME)-$(VERSION).tgz; if [ "$$?" = "0" ]; then echo; echo "Change program version in config.h, mmkay?"; echo; exit 1; fi
	cd ..; rm -rf $(PROGNAME)-$(VERSION); cp -pr $(PROGNAME) $(PROGNAME)-$(VERSION); \
	  tar -cvz -f ~/www/afl/releases/$(PROGNAME)-$(VERSION).tgz $(PROGNAME)-$(VERSION)
	chmod 644 ~/www/afl/releases/$(PROGNAME)-$(VERSION).tgz
	( cd ~/www/afl/releases/; ln -s -f $(PROGNAME)-$(VERSION).tgz $(PROGNAME)-latest.tgz )
	cat docs/README >~/www/afl/README.txt
	cat docs/status_screen.txt >~/www/afl/status_screen.txt
	cat docs/historical_notes.txt >~/www/afl/historical_notes.txt
	cat docs/technical_details.txt >~/www/afl/technical_details.txt
	cat docs/ChangeLog >~/www/afl/ChangeLog.txt
	cat docs/QuickStartGuide.txt >~/www/afl/QuickStartGuide.txt
	echo -n "$(VERSION)" >~/www/afl/version.txt

=== debian/changelog ===
afl (2.49b-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Stender <stender@debian.org>  Sat, 22 Jul 2017 14:06:01 +0200

afl (2.46b-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Stender <stender@debian.org>  Tue, 11 Jul 2017 08:28:23 +0200

afl (2.36b-2) unstable; urgency=medium

  * bump debhelper level to 10 (deb/compat and build-dep).
  * deb/copyright:
    + use https in Format field (preferred by new standards).
    + expand copyright spans to 2017.
  * bump standards to 4.0.0 (no further changes needed).

 -- Daniel Stender <stender@debian.org>  Mon, 10 Jul 2017 20:54:10 +0200

=== debian/control ===
Source: afl
Section: devel
Priority: optional
Maintainer: Daniel Stender <stender@debian.org>
Build-Depends:
 clang-3.9,
 debhelper (>= 10),
 dh-buildinfo,
 llvm-3.9-dev
Standards-Version: 4.0.0
Homepage: http://lcamtuf.coredump.cx/afl/
Vcs-Git: https://anonscm.debian.org/git/collab-maint/afl.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/afl.git

Package: afl
Architecture: any
Depends:
 build-essential,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 afl-clang,
 afl-doc
Suggests:
 gnuplot
Description: instrumentation-driven fuzzer for binary formats
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary. This substantially
 improves the functional coverage for the fuzzed code. The compact synthesized
 corpora produced by the tool are also useful for seeding other, more labor- or
 resource-intensive testing regimes down the road.
 .
 afl-fuzz is designed to be practical: it has modest performance overhead, uses
 a variety of highly effective fuzzing strategies, requires essentially no
 configuration, and seamlessly handles complex, real-world use cases - say,
 common image parsing or file compression libraries.

Package: afl-clang
Architecture: any
Depends:
 afl (= ${binary:Version}),
 clang-3.9,
 ${clang:Depends},
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 afl-doc
Breaks:
 afl (<< 1.72b)
Replaces:
 afl (<< 1.72b)
Description: instrumentation-driven fuzzer for binary formats - clang support
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary.
 .
 This package provides support for the clang compiler.

Package: afl-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends}
Recommends:
 afl,
 afl-clang
Breaks:
 afl (<= 1.96b-1)
Description: instrumentation-driven fuzzer for binary formats - documentation
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary.
 .
 This package provides the documentation, a collection of special crafted test
 cases, vulnerability samples and experimental stuff.

## afl 2.52b

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 #
 # Written and maintained by Michal Zalewski <lcamtuf@google.com>
 # 
-# Copyright 2013, 2014, 2015, 2016 Google Inc. All rights reserved.
+# Copyright 2013, 2014, 2015, 2016, 2017 Google Inc. All rights reserved.
 # 
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -111,8 +111,8 @@
 .NOTPARALLEL: clean
 
 clean:
-	rm -f $(PROGS) afl-as as afl-g++ afl-clang afl-clang++ *.o *~ a.out core core.[1-9][0-9]* *.stackdump test .test test-instr .test-instr0 .test-instr1 qemu_mode/qemu-2.3.0.tar.bz2 afl-qemu-trace
-	rm -rf out_dir qemu_mode/qemu-2.3.0
+	rm -f $(PROGS) afl-as as afl-g++ afl-clang afl-clang++ *.o *~ a.out core core.[1-9][0-9]* *.stackdump test .test test-instr .test-instr0 .test-instr1 qemu_mode/qemu-2.10.0.tar.bz2 afl-qemu-trace
+	rm -rf out_dir qemu_mode/qemu-2.10.0
 	$(MAKE) -C llvm_mode clean
 	$(MAKE) -C libdislocator clean
 	$(MAKE) -C libtokencap clean

=== libdislocator/Makefile ===
#
# american fuzzy lop - libdislocator
# ----------------------------------
#
# Written by Michal Zalewski <lcamtuf@google.com>
#
# Copyright 2016 Google Inc. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#

PREFIX      ?= /usr/local
HELPER_PATH  = $(PREFIX)/lib/afl

VERSION     = $(shell grep '^\#define VERSION ' ../config.h | cut -d '"' -f2)

CFLAGS      ?= -O3 -funroll-loops
CFLAGS      += -Wall -D_FORTIFY_SOURCE=2 -g -Wno-pointer-sign

all: libdislocator.so

libdislocator.so: libdislocator.so.c ../config.h
	$(CC) $(CFLAGS) -shared -fPIC $< -o $@ $(LDFLAGS)

.NOTPARALLEL: clean

clean:
	rm -f *.o *.so *~ a.out core core.[1-9][0-9]*
	rm -f libdislocator.so

install: all
	install -m 755 libdislocator.so $${DESTDIR}$(HELPER_PATH)
	install -m 644 README.dislocator $${DESTDIR}$(HELPER_PATH)

=== libtokencap/Makefile ===
#
# american fuzzy lop - libtokencap
# --------------------------------
#
# Written by Michal Zalewski <lcamtuf@google.com>
#
# Copyright 2016 Google Inc. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#

PREFIX      ?= /usr/local
HELPER_PATH  = $(PREFIX)/lib/afl

VERSION     = $(shell grep '^\#define VERSION ' ../config.h | cut -d '"' -f2)

CFLAGS      ?= -O3 -funroll-loops
CFLAGS      += -Wall -D_FORTIFY_SOURCE=2 -g -Wno-pointer-sign

all: libtokencap.so

libtokencap.so: libtokencap.so.c ../config.h
	$(CC) $(CFLAGS) -shared -fPIC $< -o $@ $(LDFLAGS)

.NOTPARALLEL: clean

clean:
	rm -f *.o *.so *~ a.out core core.[1-9][0-9]*
	rm -f libtokencap.so

install: all
	install -m 755 libtokencap.so $${DESTDIR}$(HELPER_PATH)
	install -m 644 README.tokencap $${DESTDIR}$(HELPER_PATH)

=== llvm_mode/Makefile ===
#
# american fuzzy lop - LLVM instrumentation
# -----------------------------------------
#
# Written by Laszlo Szekeres <lszekeres@google.com> and
#            Michal Zalewski <lcamtuf@google.com>
#
# LLVM integration design comes from Laszlo Szekeres.
#
# Copyright 2015, 2016 Google Inc. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#

PREFIX      ?= /usr/local
HELPER_PATH  = $(PREFIX)/lib/afl
BIN_PATH     = $(PREFIX)/bin

VERSION     = $(shell grep '^\#define VERSION ' ../config.h | cut -d '"' -f2)

LLVM_CONFIG ?= llvm-config

CFLAGS      ?= -O3 -funroll-loops
CFLAGS      += -Wall -D_FORTIFY_SOURCE=2 -g -Wno-pointer-sign \
               -DAFL_PATH=\"$(HELPER_PATH)\" -DBIN_PATH=\"$(BIN_PATH)\" \
               -DVERSION=\"$(VERSION)\" 
ifdef AFL_TRACE_PC
  CFLAGS    += -DUSE_TRACE_PC=1
endif

CXXFLAGS    ?= -O3 -funroll-loops
CXXFLAGS    += -Wall -D_FORTIFY_SOURCE=2 -g -Wno-pointer-sign \
               -DVERSION=\"$(VERSION)\" -Wno-variadic-macros

CLANG_CFL    = `$(LLVM_CONFIG) --cxxflags` -fno-rtti -fpic $(CXXFLAGS)
CLANG_LFL    = `$(LLVM_CONFIG) --ldflags` $(LDFLAGS)

# User teor2345 reports that this is required to make things work on MacOS X.

ifeq "$(shell uname)" "Darwin"
  CLANG_LFL += -Wl,-flat_namespace -Wl,-undefined,suppress
endif

# We were using llvm-config --bindir to get the location of clang, but
# this seems to be busted on some distros, so using the one in $PATH is
# probably better.

ifeq "$(origin CC)" "default"
  CC         = clang
  CXX        = clang++
endif

ifndef AFL_TRACE_PC
  PROGS      = ../afl-clang-fast ../afl-llvm-pass.so ../afl-llvm-rt.o ../afl-llvm-rt-32.o ../afl-llvm-rt-64.o
else
  PROGS      = ../afl-clang-fast ../afl-llvm-rt.o ../afl-llvm-rt-32.o ../afl-llvm-rt-64.o
endif

all: test_deps $(PROGS) test_build all_done

test_deps:
ifndef AFL_TRACE_PC
	@echo "[*] Checking for working 'llvm-config'..."
	@which $(LLVM_CONFIG) >/dev/null 2>&1 || ( echo "[-] Oops, can't find 'llvm-config'. Install clang or set \$$LLVM_CONFIG or \$$PATH beforehand."; echo "    (Sometimes, the binary will be named llvm-config-3.5 or something like that.)"; exit 1 )
else
	@echo "[!] Note: using -fsanitize=trace-pc mode (this will fail with older LLVM)."
endif
	@echo "[*] Checking for working '$(CC)'..."
	@which $(CC) >/dev/null 2>&1 || ( echo "[-] Oops, can't find '$(CC)'. Make sure that it's in your \$$PATH (or set \$$CC and \$$CXX)."; exit 1 )
	@echo "[*] Checking for '../afl-showmap'..."
	@test -f ../afl-showmap || ( echo "[-] Oops, can't find '../afl-showmap'. Be sure to compile AFL first."; exit 1 )
	@echo "[+] All set and ready to build."

../afl-clang-fast: afl-clang-fast.c | test_deps
	$(CC) $(CFLAGS) $< -o $@ $(LDFLAGS)
	ln -sf afl-clang-fast ../afl-clang-fast++

../afl-llvm-pass.so: afl-llvm-pass.so.cc | test_deps
	$(CXX) $(CLANG_CFL) -shared $< -o $@ $(CLANG_LFL)

../afl-llvm-rt.o: afl-llvm-rt.o.c | test_deps
	$(CC) $(CFLAGS) -fPIC -c $< -o $@

../afl-llvm-rt-32.o: afl-llvm-rt.o.c | test_deps
	@printf "[*] Building 32-bit variant of the runtime (-m32)... "
	@$(CC) $(CFLAGS) -m32 -fPIC -c $< -o $@ 2>/dev/null; if [ "$$?" = "0" ]; then echo "success!"; else echo "failed (that's fine)"; fi

../afl-llvm-rt-64.o: afl-llvm-rt.o.c | test_deps
	@printf "[*] Building 64-bit variant of the runtime (-m64)... "
	@$(CC) $(CFLAGS) -m64 -fPIC -c $< -o $@ 2>/dev/null; if [ "$$?" = "0" ]; then echo "success!"; else echo "failed (that's fine)"; fi

test_build: $(PROGS)
	@echo "[*] Testing the CC wrapper and instrumentation output..."
	unset AFL_USE_ASAN AFL_USE_MSAN AFL_INST_RATIO; AFL_QUIET=1 AFL_PATH=. AFL_CC=$(CC) ../afl-clang-fast $(CFLAGS) ../test-instr.c -o test-instr $(LDFLAGS)
	echo 0 | ../afl-showmap -m none -q -o .test-instr0 ./test-instr
	echo 1 | ../afl-showmap -m none -q -o .test-instr1 ./test-instr
	@rm -f test-instr
	@cmp -s .test-instr0 .test-instr1; DR="$$?"; rm -f .test-instr0 .test-instr1; if [ "$$DR" = "0" ]; then echo; echo "Oops, the instrumentation does not seem to be behaving correctly!"; echo; echo "Please ping <lcamtuf@google.com> to troubleshoot the issue."; echo; exit 1; fi
	@echo "[+] All right, the instrumentation seems to be working!"

all_done: test_build
	@echo "[+] All done! You can now use '../afl-clang-fast' to compile programs."

.NOTPARALLEL: clean

clean:
	rm -f *.o *.so *~ a.out core core.[1-9][0-9]* test-instr .test-instr0 .test-instr1 
	rm -f $(PROGS) ../afl-clang-fast++

=== debian/changelog ===
afl (2.52b-5) unstable; urgency=medium

  * deb/control:
    + bump standards to 4.3.0 (no changes needed).
  * deb/rules:
    + don't check for flag "terse" manually.

 -- Daniel Stender <stender@debian.org>  Sun, 27 Jan 2019 13:00:29 +0100

afl (2.52b-4) unstable; urgency=medium

  * deb/rules:
    + use override for dh_install to run dh_install and stuff, not
      somewhere else (cosmetical measure).
    + let dh_strip_nondeterminism run but not on docs package.
    + add loop to set DH_VERBOSE=1 if terse tag isn't found in
      DEB_BUILD_OPTIONS (following standards 4.2.0).
  * deb/control: bump standards to 4.2.1 (no further changes).
  * deb/tests: Use AUTOPKGTEST_TMP instead of ADTTMP [Ondřej Nový].
  * build with debhelper level 11:
    + bump dh version in deb/compat.
    + bump package version in deb/control.
    + add override for dh_strip to prevent processing afl-doc in deb/rules.
    + remove deprecated --fail-missing from dh_install in deb/rules.

 -- Daniel Stender <stender@debian.org>  Mon, 29 Oct 2018 21:46:01 +0100

afl (2.52b-3) unstable; urgency=medium

  * build against llvm 6.0 (Closes: #893403).
  * deb/rules: give $CXX for llvm_mode build to prevent build break.

 -- Daniel Stender <stender@debian.org>  Wed, 08 Aug 2018 23:13:25 +0200

afl (2.52b-2) unstable; urgency=medium

  * deb/control:
    + bump standards version to 4.1.3 (no changes needed).
    + update Vcs- fields (project moved to Salsa).
  * deb/copyright:
    + expand copyright span.
  * add debian/gbp.conf.

 -- Daniel Stender <stender@debian.org>  Mon, 19 Feb 2018 19:55:08 +0100

afl (2.52b-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Stender <stender@debian.org>  Wed, 08 Nov 2017 07:48:59 +0100

afl (2.51b-1) unstable; urgency=medium

  * New upstream release.
  * Build and run against clang/LLVM 4.0 (changes in deb/control and
    hardcode-clang-version.patch, Closes: #873404).

 -- Daniel Stender <stender@debian.org>  Tue, 17 Oct 2017 17:38:21 +0200

afl (2.50b-1) unstable; urgency=medium

  * New upstream release.
  * fix path to documentation put out by executeables:
    + add change-docpath.patch
    + adjust custom removals in deb/rules accordingly
    + changes in deb/afl-docs.install
  * add deb/afl-doc.links (installing link to README as it's pointed
    to by the tools).
  * deb/rules: add .txt to saves from dh_compress (otherwise specific pointers
    to docs from the tools mislead).

 -- Daniel Stender <stender@debian.org>  Fri, 25 Aug 2017 11:29:05 +0200

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,14 @@
 Priority: optional
 Maintainer: Daniel Stender <stender@debian.org>
 Build-Depends:
- clang-3.9,
- debhelper (>= 10),
+ clang-6.0,
+ debhelper (>= 11),
  dh-buildinfo,
- llvm-3.9-dev
-Standards-Version: 4.0.0
+ llvm-6.0-dev
+Standards-Version: 4.3.0
 Homepage: http://lcamtuf.coredump.cx/afl/
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/afl.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/afl.git
+Vcs-Git: https://salsa.debian.org/debian/afl.git
+Vcs-Browser: https://salsa.debian.org/debian/afl
 
 Package: afl
 Architecture: any
@@ -40,7 +40,7 @@
 Architecture: any
 Depends:
  afl (= ${binary:Version}),
- clang-3.9,
+ clang-6.0,
  ${clang:Depends},
  ${misc:Depends},
  ${shlibs:Depends}

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

cflags_nopie = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie dpkg-buildflags --get CFLAGS)
ldflags_nopie = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie dpkg-buildflags --get LDFLAGS)

# don't emit NEON instructions whatsoever to prevent FTBFS on machines which
# doesn't support that, see #842143 [thanks to Paul Wise]
ifeq "$(shell dpkg-architecture -q DEB_HOST_ARCH)" "armhf"
clang_cflags := $(CFLAGS) -mfpu=vfpv3
clang_cxxflags := $(CXXFLAGS) -mfpu=vfpv3
endif

export HOSTNAME =
export PREFIX = /usr

ifeq "$(filter i386 amd64,$(shell dpkg-architecture -q DEB_HOST_ARCH_CPU))" ""
export AFL_NO_X86 = 1
endif

%:
	dh $@

override_dh_auto_build:
	$(MAKE)
	CFLAGS="$(cflags_nopie)" LDFLAGS="$(ldflags_nopie)" $(MAKE) -C libdislocator
	CFLAGS="$(cflags_nopie)" LDFLAGS="$(ldflags_nopie)" $(MAKE) -C libtokencap
	CFLAGS="$(clang_cflags)" CXXFLAGS="$(clang_cxxflags)" $(MAKE) -C llvm_mode CXX=g++
# CXX against build break with llvm 5.0: https://groups.google.com/d/topic/afl-users/D3-jbylxHeg (thanks to Jakub Wilk)

override_dh_auto_install:
	$(MAKE) install DESTDIR=debian/tmp
	rm debian/tmp/usr/share/doc/afl-doc/docs/ChangeLog
	rm debian/tmp/usr/share/doc/afl-doc/docs/README
	$(MAKE) -C libdislocator install DESTDIR=$(CURDIR)/debian/tmp
	$(MAKE) -C libtokencap install DESTDIR=$(CURDIR)/debian/tmp

override_dh_install:
	dh_install
ifneq "$(AFL_NO_X86)" ""
	cd debian/afl/usr/bin/ && rm afl-gcc afl-g++
	cd debian/afl/usr/lib/afl/ && rm as afl-as
	cd debian/afl-clang/usr/bin/ && rm afl-clang afl-clang++
endif

override_dh_installdocs:
	dh_installdocs -A docs/README
	dh_buildinfo -Nafl-doc

override_dh_strip_nondeterminism:
	dh_strip_nondeterminism -Nafl-doc # don't touch docs package, see #803503

override_dh_compress:
	dh_compress -X.c -X.mp4 -X.sql -XREADME -X.txt

override_dh_strip:
	dh_strip -Nafl-doc

override_dh_gencontrol:
#	debian/dh_clang -p afl-clang
	dh_gencontrol

=== debian/watch ===
version=3
http://lcamtuf.coredump.cx/afl/releases/afl-([0-9.]+[a-z]*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))$
